"""
list comprehension ne mora da se koristi samo za pravljenje listi;
primeri u nastavku...
"""
def recnikComp():
    rec = "matematika"
    # pravi recnik od slova i broja njihovih pojavljivanja u reci
    #recnik = {slovo : rec.count(slovo) for slovo in rec}
    recnik = {slovo : rec.count(slovo) for slovo in set(rec)}
    # da se ne bi ponavljalo racunanje, iz reci cemo da izvucemo jedinstvena slova
    # - pomocu set(rec); tako smo "izbacili" visesturko racunanje,
    # pri cemu rec svakako ostaje nepromenjena
    print(recnik)

def skupComp():
    # pravi skup iskljucivo malih slova koje se pojavljuju u reci
    rec = "Antananarive"
    skup = {slovo for slovo in rec if slovo.islower()}
    print(skup)

def paran(x):
    if (x % 2 == 0):
        return True
    else:
        return False
def naTreci(x):
    return x**3

def main():
    """
    List comprehension moze u sebi da sadrzi i poziv funkcije.
    Ako zovemo funkciju kao "filter" za listu, funkcija mora primati samo jedan
    argument (ili imati ostale podrazumevane) i mora da vraca True/False.
    Ako pozivamo funkciju za pravljenje vrednosti, ona mora da vrati neku vrednost.
    """
    parni = [naTreci(x) for x in range(1, 20) if not paran(x)]
    print(parni)
    recnikComp()
    skupComp()

if __name__ == '__main__':
    main()
