#!/usr/local/bin/python
# -*- coding: utf-8 -*-
__author__ = "acko"

import random

def generateRandomMatrix(numberOfRows, numberOfColumns, low, high):
    if numberOfRows <= 0 or numberOfColumns <= 0:
        return None
    return [[random.randint(low, high) for i in range(numberOfColumns)] for i in range(numberOfRows)]

if __name__ == "__main__":
    # prvo učitamo broj redova i kolona kao jedan veliki string
    # zatim ga podelimo uzimajući znak razmaka kao separator
    # i na kraju mapiramo dobijene stringove u intove
    (numberOfRows, numberOfColumns, low, high) = map(int, input("Enter the number of rows and columns and also the range of the elements seperated by a space and press ENTER: ").split(' '))

    matrix = generateRandomMatrix(numberOfRows, numberOfColumns, low, high)
    if matrix is None:
        print("Invalid dimensions!")
        exit()

    print("---")
    # štampamo matricu
    print("\n".join(", ".join(map(str, row)) for row in matrix))

    print("---")
    # pešački računamo sumu
    totalSum = 0
    for row in matrix:
        for element in row:
            totalSum += element
    print(totalSum)

    print("---")
    # kraći način
    print(sum([sum(row) for row in matrix]))
