#!/usr/local/bin/python
# -*- coding: utf-8 -*-
__author__ = "acko"

def generateMatrix(numberOfRows, numberOfColumns, initialValue = 0):
    if numberOfRows <= 0 or numberOfColumns <= 0:
        return None
    return [[initialValue] * numberOfColumns for i in range(numberOfRows)]

if __name__ == "__main__":
    # prvo učitamo broj redova i kolona kao jedan veliki string
    # zatim ga podelimo uzimajući znak razmaka kao separator
    # i na kraju mapiramo dobijene stringove u intove
    (numberOfRows, numberOfColumns) = map(int, input("Enter the number of rows and columns seperated by a space and press ENTER: ").split(' '))

    print(numberOfRows, numberOfColumns)
    print(type(numberOfRows), type(numberOfColumns))

    matrix = generateMatrix(numberOfRows, numberOfColumns)
    if matrix is None:
        print("Invalid dimensions!")
        exit()

    print("---")
    # štampamo svaki element u posebnom redu
    for row in matrix:
        for element in row:
            print(element)

    print("---")
    # štampamo matricu onako kako se očekuje
    for row in matrix:
        # svaki element u redu prvo mapiramo u string
        # zatim tu listu stringova spojimo gde kao separator koristimo
        # string ", "
        print(", ".join(map(str, row)))

    print("---")
    # štampamo matricu onako kako se očekuje samo mnogo lepše :)
    print("\n".join(", ".join(map(str, row)) for row in matrix))

